
#include <stdio.h>
#include <curl/curl.h>

char *kpfilestr = NULL;
char *kpurl = NULL;

char *kp_next(void);
int kp_get_lineno(void);
static void kp_shutdown(void);

#ifndef MAXKPFILESTR
#define MAXKPFILESTR 4096
#endif

CURL *curl;
CURLcode cres;

int lineno = 0;

extern ices_config_t ices_config;

int playlist_kplaylist_init(playlist_module_t* pm)
{
	int ml = 0;

	ml += strlen(ices_config.pm.kplaylist_url);
	ml += strlen(ices_config.pm.kplaylist_password);
	ml += strlen(ices_config.pm.kplaylist_id);
	ml += 64;
	
	kpurl = (char *) malloc(ml);	
	if (kpurl)
	{
		memset(kpurl, 0, ml);
		sprintf(kpurl, "%s?radionext=%s&pass=%s", ices_config.pm.kplaylist_url, ices_config.pm.kplaylist_id, ices_config.pm.kplaylist_password);
		printf("Generated kPlaylist URL: %s\n", kpurl);
	} else 
	{
		printf("Could not allocate memory for kPlaylist url.\n");
		exit(1);
	}
	
	pm->get_next = kp_next;
	pm->get_metadata = NULL;
	pm->get_lineno = kp_get_lineno;
	pm->shutdown = kp_shutdown;	

	return 1;
}

static void kp_shutdown(void)
{
	if (kpurl) free(kpurl);
}

int kp_get_lineno(void)
{
	return lineno;
}

int kpcbwrite(void *buffer, size_t size, size_t nmemb, void *stream)
{
	int bufferlen = size * nmemb;

	if (bufferlen < MAXKPFILESTR)
	{
		memset(kpfilestr, 0, MAXKPFILESTR);
		memcpy(kpfilestr, buffer, bufferlen);
		return bufferlen;
	}
	return 0;
}

int kp_next_get(void)
{
	if (kpfilestr)
	{
		curl = curl_easy_init();
		if (curl) 
		{
			curl_easy_setopt(curl, CURLOPT_URL, kpurl);
			curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, kpcbwrite);
	
			cres = curl_easy_perform(curl);
			curl_easy_cleanup(curl);

			if (CURLE_OK == cres && strlen(kpfilestr) > 0) return 1;
		}	
	} else 
	{
		printf("Error in malloc/kp_next()\n");
		exit(1);
	}
	return 0;
}

char *kp_next(void)
{
	kpfilestr = (char *) malloc(MAXKPFILESTR);	

	while (kp_next_get() == 0) 
	{
		return NULL;
		printf("Sleeping ... \n");
		sleep(5);
	}

	if (kpfilestr)
	{
		lineno++;
		return kpfilestr;

	} else 
	{
		printf("Error in retrieving next/kp_next()\n");
		exit(1);
	}
}

